
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Segmentation_GUI &#8212; Documentation Segmentation Image 4.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Segmentation_GUI</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/01/2019</span>
<span class="c1"># Classe Application Version 2</span>
<span class="c1">#####################################</span>

<span class="c1">### IMPORTATION DES BIBLIOTHEQUES </span>
<span class="kn">import</span> <span class="nn">tkinter.filedialog</span> <span class="k">as</span> <span class="nn">tkfd</span>
<span class="kn">import</span> <span class="nn">tkinter</span> <span class="k">as</span> <span class="nn">tk</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">math</span> <span class="k">import</span> <span class="n">ceil</span>
<span class="c1"># import matplotlib.pyplot as plt</span>
<span class="c1"># import matplotlib.image as mpimg</span>
<span class="c1"># import time</span>

<span class="c1">### IMPORTATION DES CLASSES</span>
<span class="kn">from</span> <span class="nn">Image</span> <span class="k">import</span> <span class="n">Image</span>
<span class="kn">from</span> <span class="nn">Graphe</span> <span class="k">import</span> <span class="n">Graphe</span>
<span class="kn">from</span> <span class="nn">Sommet</span> <span class="k">import</span> <span class="n">Sommet</span>
<span class="kn">from</span> <span class="nn">Partage_eaux</span> <span class="k">import</span> <span class="n">Partage_eaux</span>

<span class="c1">### CONSTANTES LES LISTES ELEMENTS STRUCTURANTS</span>
<span class="n">Gamma_4</span><span class="o">=</span><span class="p">[[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">],[</span><span class="mi">0</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">],[</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">],[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">]]</span>
<span class="n">Gamma_8</span><span class="o">=</span><span class="p">[[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">],[</span><span class="mi">0</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">],[</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">],[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">],[</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">],[</span><span class="mi">1</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">],[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">],[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">]]</span>
<span class="n">Gamma</span><span class="o">=</span><span class="p">[</span><span class="n">Gamma_4</span><span class="p">,</span><span class="n">Gamma_8</span><span class="p">]</span>

<span class="c1">### Application d&#39;affichage principale ( FENETRE TKINTER )</span>

<div class="viewcode-block" id="Application"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application">[docs]</a><span class="k">class</span> <span class="nc">Application</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    </span>
<span class="sd">    **AUTRES CLASSES IMPORTEES**</span>
<span class="sd">    </span>
<span class="sd">    * Image</span>
<span class="sd">    * Graphe</span>
<span class="sd">    * Sommet</span>
<span class="sd">    * tkinter</span>
<span class="sd">    * tkinter.filedialog</span>
<span class="sd">    * numpy</span>
<span class="sd">   </span>
<span class="sd">    </span>
<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Application.__init__"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Constructeur de l&#39;objet fenêtre principale de l&#39;application</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Application</span>
<span class="sd">        :rtype: Application</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.filepath Adresse du fichier image sur la machine</span>
<span class="sd">        * self.photo Ouverture du fichier image a traiter au format PNG niveau de gris et stockage dans la variable photo</span>
<span class="sd">        * self.img Instance d&#39;un objet Image créé à partir du fichier ci dessus</span>
<span class="sd">        * self.Liste_points Liste des points de repérage des zones</span>
<span class="sd">        </span>
<span class="sd">        Les frames</span>
<span class="sd">        * self.Frame1</span>
<span class="sd">        * self.Frame2</span>
<span class="sd">        * self.Frame3</span>
<span class="sd">        * self.Frame4</span>
<span class="sd">        * self.Frame5</span>
<span class="sd">        * self.Frame5T</span>
<span class="sd">        * self.Frame5T1</span>
<span class="sd">        * self.Frame5T2</span>
<span class="sd">        * self.Frame5B</span>
<span class="sd">        * self.Frame5B1</span>
<span class="sd">        * self.Frame5B2</span>
<span class="sd">        * self.Frame6</span>
<span class="sd">        * self.Frame7</span>
<span class="sd">        * self.Frame8</span>
<span class="sd">        </span>
<span class="sd">        Les widgets et champs associés</span>
<span class="sd">        * self.no_algo Numéro de l&#39;algorithme à appliquer </span>
<span class="sd">        * self.bouton1 Bouton radio de sélection de l&#39;algorithme 1 (Ford Fulkerson - Bellman-Ford)</span>
<span class="sd">        * self.bouton2 Bouton radio de sélection de l&#39;algorithme 2 (Edmond Karp)</span>
<span class="sd">        * self.bouton3 Bouton radio de sélection de l&#39;algorithme 3 (Partage des eaux)</span>
<span class="sd">        </span>
<span class="sd">        * self.Pourcentage le paramètre Pourcentage servira d&#39;argument aux algorithme de graph cut en cas de besoin</span>
<span class="sd">        * self.scale curseur permettant de déterminer le paramètre Pourcentage.</span>
<span class="sd">        </span>
<span class="sd">        * self.Rayon le paramètre Rayon servira d&#39;argument aux algorithme de graph cut en cas de besoin</span>
<span class="sd">        * self.scale_2 curseur permettant de déterminer le paramètre Rayon.</span>
<span class="sd">        </span>
<span class="sd">        * self.gamma choix de l&#39;élément structurant pour de l&#39;algorithme de partage des eaux</span>
<span class="sd">        * self.bouton4 Bouton radio de sélection de l&#39;élément structurant Gamma_4</span>
<span class="sd">        * self.bouton5 Bouton radio de sélection de l&#39;élément structurant Gamma_8</span>
<span class="sd">        </span>
<span class="sd">        * self.zone_col choix de la zone à colorier pour l&#39;algorithme de partage des eaux</span>
<span class="sd">        * self.bouton6 Bouton radio de sélection pour le coloriage de l&#39;arrière plan</span>
<span class="sd">        * self.bouton7 Bouton radio de sélection pour le coloriage de l&#39;objet</span>
<span class="sd">        </span>
<span class="sd">        * self.sv_obj Elément StringVar de Tkinter permettant l&#39;affichage de la liste des points de l&#39;objet selectionnes dans la fenetre</span>
<span class="sd">        * self.bouton_init_obj Bouton de reinitialisation de la liste des points de l&#39;objet a vide</span>
<span class="sd">        </span>
<span class="sd">        * self.sv_bkg Elément StringVar de Tkinter permettant l&#39;affichage de la liste des points de l&#39;arrière plan selectionnes dans la fenetre</span>
<span class="sd">        * self.bouton_init_bkg Bouton de reinitialisation de la liste des points de l&#39;arrière plan a vide</span>
<span class="sd">        </span>
<span class="sd">        </span>
<span class="sd">        * self.canvas Canevas d&#39;affichage du fichier image</span>
<span class="sd">        * self.bouton_importation Bouton d&#39;importation d&#39;une nouvelle image</span>
<span class="sd">        * self.bouton_calcul Bouton de lancement calcul des zones</span>
<span class="sd">        * self.bouton_affichage Bouton d&#39;affichage des zones segmentées</span>
<span class="sd">        * self.bouton_exportation Bouton d&#39;exportation</span>
<span class="sd">        * self.bouton_sortie Bouton pour quitter l&#39;application</span>
<span class="sd">        </span>
<span class="sd">        La fenêtre principale</span>
<span class="sd">        * self.fenetre Fenêtre d&#39;affichage</span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1">## Creation de la fenetre</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s2">&quot;SEGMENTATION D&#39;IMAGE&quot;</span><span class="p">)</span>
        
        <span class="c1">## Initialisation des variables de classe</span>

        <span class="c1"># Selection du fichier image a traiter au format PNG niveau de gris a l&#39;aide d&#39;une fenetre de selection</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">filepath</span> <span class="o">=</span> <span class="n">tkfd</span><span class="o">.</span><span class="n">askopenfilename</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s2">&quot;Ouvrir une image&quot;</span><span class="p">,</span><span class="n">filetypes</span><span class="o">=</span><span class="p">[(</span><span class="s1">&#39;png files&#39;</span><span class="p">,</span><span class="s1">&#39;.png&#39;</span><span class="p">),(</span><span class="s1">&#39;all files&#39;</span><span class="p">,</span><span class="s1">&#39;.*&#39;</span><span class="p">)])</span>
        
        <span class="c1"># Ouverture du fichier image a traiter au format PNG niveau de gris et stockage dans la variable photo</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">photo</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">PhotoImage</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">filepath</span><span class="p">)</span>
        
        <span class="c1"># Creation d&#39;une instance de Image à partir du fichier</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">=</span><span class="n">Image</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">filepath</span><span class="p">)</span>
        
        <span class="c1"># Liste des points de repérage des zones objet</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="o">=</span><span class="p">[]</span>
        
        <span class="c1"># Liste des points de repérage des zones arrière plan</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="o">=</span><span class="p">[]</span>
        
        <span class="c1">## Label de la fenetre principale &#39;fenetre&#39;</span>
        <span class="c1"># self.label = tk.Label(self.fenetre, text=&quot;SEGMENTATION D&#39;IMAGE&quot;,bg=&quot;ivory&quot;,font=(&quot;Helvetica&quot;, 28))</span>
        <span class="c1"># self.label.pack()</span>
        
        <span class="c1">## Organisation des Frames</span>
        <span class="c1"># Frame1 dans fenetre</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">LEFT</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span>
        
        <span class="c1"># Frame2 dans fenetre</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame2</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame3 dans Frame2</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame3</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame2</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame3</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">TOP</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 4 dans Frame2</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame4</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame2</span><span class="p">,</span> <span class="n">bg</span><span class="o">=</span><span class="s2">&quot;white&quot;</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame4</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">40</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">40</span><span class="p">)</span>
        
        <span class="c1"># Frame 5 dans Frame 4</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame2</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">TOP</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 5T dans Frame 5</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">TOP</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 5B dans Frame 5</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>

        <span class="c1"># Frame 5T1 dans Frame 5T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T1</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">TOP</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 5T2 dans Frame 5T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T2</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>

        <span class="c1"># Frame 5B1 dans Frame 5B</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B1</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">TOP</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>  
        
        <span class="c1"># Frame 5B2 dans Frame 5B</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B2</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>        
        
        <span class="c1"># Frame 6 dans Frame 4</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame6</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame4</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame6</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">BOTTOM</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 7 dans Frame 6</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame6</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">LEFT</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1"># Frame 8 dans Frame 6</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame8</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame6</span><span class="p">,</span> <span class="n">borderwidth</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">relief</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">GROOVE</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame8</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">RIGHT</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        
        <span class="c1">## Ajout de labels pour les Frames</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;CHOIX DES PARAMETRES&quot;</span><span class="p">,</span><span class="n">font</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Helvetica&quot;</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="s1">&#39;bold&#39;</span><span class="p">))</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame3</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;LISTE DES POINTS SELECTIONNES&quot;</span><span class="p">,</span><span class="n">font</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Helvetica&quot;</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="s1">&#39;bold&#39;</span><span class="p">))</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;top&quot;</span><span class="p">)</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Cliquez sur l&#39;image avec le bouton droit de la souris pour sélectionner les points définissant les zones objet et ctrl-bouton droit pour déterminer les points de l&#39;arrière plan&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5T1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Objets&quot;</span><span class="p">,</span><span class="n">font</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Helvetica&quot;</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s1">&#39;bold&#39;</span><span class="p">))</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5B1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Arrière plan&quot;</span><span class="p">,</span><span class="n">font</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Helvetica&quot;</span><span class="p">,</span> <span class="mi">8</span><span class="p">,</span> <span class="s1">&#39;bold&#39;</span><span class="p">))</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">padx</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span>

        <span class="c1">## Ajouts des Widgets</span>

        <span class="c1"># Parametre de choix d&#39;algorithme</span>
        <span class="c1"># radiobutton</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">StringVar</span><span class="p">()</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton1</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Ford-Fulkerson-Bellman-Ford&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton2</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Ford-Fulkerson-Edmond-Karp&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton3</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Partage des eaux&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">3</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton2</span><span class="o">.</span><span class="n">select</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton1</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton2</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton3</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Parametre Pourcentage determine a l&#39;aide d&#39;un curseur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Pourcentage</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">DoubleVar</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scale</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Scale</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">orient</span><span class="o">=</span><span class="s1">&#39;horizontal&#39;</span><span class="p">,</span> <span class="n">from_</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">to</span><span class="o">=</span><span class="mi">100</span><span class="p">,</span> <span class="n">resolution</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">tickinterval</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">length</span><span class="o">=</span><span class="mi">350</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">Pourcentage</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Pourcentage de seuil pour le graphe de flots&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scale</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Parametre Rayon determine a l&#39;aide d&#39;un curseur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Rayon</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">DoubleVar</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scale_2</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Scale</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">orient</span><span class="o">=</span><span class="s1">&#39;horizontal&#39;</span><span class="p">,</span> <span class="n">from_</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">to</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">resolution</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">tickinterval</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">length</span><span class="o">=</span><span class="mi">350</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">Rayon</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Rayon des boules de sélection pour le graphe de flots&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">scale_2</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Paramètre pour la ligne de partage des eaux : Gama_4 ou Gamma_8</span>
        <span class="c1"># radiobutton</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">gamma</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">StringVar</span><span class="p">()</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton4</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Gamma 4 (4 voisins pour Partage des Eaux)&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gamma</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton5</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Gamma 8 (8 voisins pour Partage des Eaux)&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">gamma</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton4</span><span class="o">.</span><span class="n">select</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton4</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton5</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Paramètre pour l&#39;affichage final : coloriage de l&#39;objet où du fond</span>
        <span class="c1"># radiobutton</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">zone_col</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">StringVar</span><span class="p">()</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton6</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Colorie arrière-plan pour Partage des Eaux&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">zone_col</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton7</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Radiobutton</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Colorie objet pour Partage des Eaux&quot;</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">zone_col</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton6</span><span class="o">.</span><span class="n">select</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton6</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton7</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Affichage de la liste des points objets selectionnes dans la fenetre</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_obj</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">StringVar</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">LabelFrame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Liste des points objets sélectionnés&quot;</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5T</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">fill</span><span class="o">=</span><span class="s2">&quot;both&quot;</span><span class="p">,</span> <span class="n">expand</span><span class="o">=</span><span class="s2">&quot;yes&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_obj</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="p">))</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5T1</span><span class="p">,</span> <span class="n">textvariable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">sv_obj</span><span class="p">)</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>

        <span class="c1"># bouton de reinitialisation de la liste des points objets a vide </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_init_obj</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5T2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Réinitialisation de la liste des points de l&#39;objet&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_obj_nulle</span> <span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_init_obj</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>    
        
        <span class="c1"># en cas de clik droit de la souris, appel de la fonction select_pixel_maj pour mise a jour de la liste objet et de l&#39;affichage</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="o">.</span><span class="n">bind</span><span class="p">(</span><span class="s2">&quot;&lt;Button-3&gt;&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">select_pixel_obj_maj</span> <span class="p">)</span>
        
        <span class="c1"># Affichage de la liste des points arrière plans selectionnes dans la fenetre</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_bkg</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">StringVar</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">LabelFrame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Liste des points de l&#39;arrière-plan sélectionnés&quot;</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Frame5B</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">fill</span><span class="o">=</span><span class="s2">&quot;both&quot;</span><span class="p">,</span> <span class="n">expand</span><span class="o">=</span><span class="s2">&quot;yes&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_bkg</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="p">))</span>
        <span class="n">tk</span><span class="o">.</span><span class="n">Label</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5B1</span><span class="p">,</span> <span class="n">textvariable</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">sv_bkg</span><span class="p">)</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># bouton de reinitialisation de la liste des points arrière plan a vide </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_init_bkg</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame5B2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="s2">&quot;Réinitialisation de la liste des points de l&#39;arrière plan&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_bkg_nulle</span> <span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_init_bkg</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># en cas de ctrl-clik droit de la souris, appel de la fonction select_pixel_maj pour mise a jour de la liste arrière plan et de l&#39;affichage</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="o">.</span><span class="n">bind</span><span class="p">(</span><span class="s2">&quot;&lt;Control-Button-3&gt;&quot;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">select_pixel_bkg_maj</span> <span class="p">)</span>
        
        <span class="c1"># Affichage du fichier image</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">canvas</span> <span class="o">=</span> <span class="n">tk</span><span class="o">.</span><span class="n">Canvas</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">photo</span><span class="o">.</span><span class="n">width</span><span class="p">(),</span> <span class="n">height</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">photo</span><span class="o">.</span><span class="n">height</span><span class="p">(),</span> <span class="n">bg</span><span class="o">=</span><span class="s2">&quot;gray&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">canvas</span><span class="o">.</span><span class="n">create_image</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">anchor</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">NW</span><span class="p">,</span> <span class="n">image</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">photo</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">canvas</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
        
        <span class="c1"># Bouton d&#39;importation</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_importation</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span><span class="p">,</span> <span class="n">text</span> <span class="o">=</span> <span class="s2">&quot;Importer&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">import_image</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_importation</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;left&quot;</span><span class="p">)</span>
        
        <span class="c1"># Bouton de calcul</span>
        <span class="c1"># self.bouton_calcul=tk.Button(self.Frame7, text = &quot;Calculer&quot;, command = self.calcul_zone_0) # essai selection listes points</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_calcul</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span><span class="p">,</span> <span class="n">text</span> <span class="o">=</span> <span class="s2">&quot;Calculer&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">calcul_zone</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_calcul</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;left&quot;</span><span class="p">)</span>
        
        <span class="c1"># Bouton d&#39;affichage</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_affichage</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span><span class="p">,</span> <span class="n">text</span> <span class="o">=</span> <span class="s2">&quot;Afficher&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">affiche_zone</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_affichage</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;left&quot;</span><span class="p">)</span>
        
        <span class="c1"># Bouton d&#39;exportation</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_exportation</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame7</span><span class="p">,</span> <span class="n">text</span> <span class="o">=</span> <span class="s2">&quot;Exporter&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">exporte_image</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_exportation</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;left&quot;</span><span class="p">)</span>
        
        <span class="c1"># Bouton de sortie</span>
        <span class="c1"># command = self.fenetre.quit fenetre.quit plante la 2eme fois - comment quitter l&#39;application ? </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_sortie</span><span class="o">=</span><span class="n">tk</span><span class="o">.</span><span class="n">Button</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Frame8</span><span class="p">,</span> <span class="n">text</span> <span class="o">=</span> <span class="s2">&quot;Quitter&quot;</span><span class="p">,</span> <span class="n">command</span> <span class="o">=</span> <span class="n">exit</span> <span class="p">)</span> 
        <span class="bp">self</span><span class="o">.</span><span class="n">bouton_sortie</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s2">&quot;right&quot;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">fenetre</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span></div>


    <span class="c1">## FONCTIONS ASSOCIEES AUX WIDGETS</span>

<div class="viewcode-block" id="Application.liste_obj_nulle"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.liste_obj_nulle">[docs]</a>    <span class="k">def</span> <span class="nf">liste_obj_nulle</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction d&#39;initialisation de la liste des points Liste_point_obj</span>
<span class="sd">        procedure sans argument qui remet la variable globale Listepoints a vide </span>
<span class="sd">        et qui met a jour son affichage dans la fenetre graphique</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
    
        <span class="k">global</span> <span class="n">Liste_points_obj</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="o">=</span><span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_obj</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="p">))</span></div>
        
<div class="viewcode-block" id="Application.liste_bkg_nulle"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.liste_bkg_nulle">[docs]</a>    <span class="k">def</span> <span class="nf">liste_bkg_nulle</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction d&#39;initialisation de la liste des points Liste_point_bkg</span>
<span class="sd">        procedure sans argument qui remet la variable globale Listepoints a vide </span>
<span class="sd">        et qui met a jour son affichage dans la fenetre graphique</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
    
        <span class="k">global</span> <span class="n">Liste_points_bkg</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="o">=</span><span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_bkg</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="p">))</span></div>
     

<div class="viewcode-block" id="Application.select_pixel_obj"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.select_pixel_obj">[docs]</a>    <span class="k">def</span> <span class="nf">select_pixel_obj</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">event</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Fonction de sélection de pixel objets a la souris</span>
<span class="sd">        Quand l&#39;évènement évènement event (qui sera le click droit de la souris) se produit , collecte les coordonnees X,Y du point clique et ajoute [X,Y] à la liste Liste_point_obj (variable globale).</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param event: Objet Event  </span>
<span class="sd">        :type event: Event</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">X</span><span class="o">=</span><span class="n">event</span><span class="o">.</span><span class="n">x</span>
        <span class="n">Y</span><span class="o">=</span><span class="n">event</span><span class="o">.</span><span class="n">y</span>
        <span class="k">if</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">Y</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">hauteur</span> <span class="ow">and</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">X</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">largeur</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">])</span></div>
        
<div class="viewcode-block" id="Application.select_pixel_bkg"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.select_pixel_bkg">[docs]</a>    <span class="k">def</span> <span class="nf">select_pixel_bkg</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">event</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Fonction de sélection de pixel arrière plan a la souris</span>
<span class="sd">        Quand l&#39;évènement évènement event (qui sera le click droit de la souris) se produit , collecte les coordonnees X,Y du point clique et ajoute [X,Y] à la liste Liste_point_bkg (variable globale).</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param event: Objet Event  </span>
<span class="sd">        :type event: Event</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">X</span><span class="o">=</span><span class="n">event</span><span class="o">.</span><span class="n">x</span>
        <span class="n">Y</span><span class="o">=</span><span class="n">event</span><span class="o">.</span><span class="n">y</span>
        <span class="k">if</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">Y</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">hauteur</span> <span class="ow">and</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">X</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">largeur</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="Application.select_pixel_obj_maj"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.select_pixel_obj_maj">[docs]</a>    <span class="k">def</span> <span class="nf">select_pixel_obj_maj</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">event</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Gestion de la selection des points : quand l&#39;évènement event (se sera click droit de la souris sur l&#39;image) se produit , la liste Liste_points_obj est augmentee des coordonnees du point clique et l&#39;affichage de cette liste est mise a jour. </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param event: Objet Event  </span>
<span class="sd">        :type event: Event</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
    
        <span class="bp">self</span><span class="o">.</span><span class="n">select_pixel_obj</span><span class="p">(</span><span class="n">event</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_obj</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="p">))</span></div>
        
<div class="viewcode-block" id="Application.select_pixel_bkg_maj"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.select_pixel_bkg_maj">[docs]</a>    <span class="k">def</span> <span class="nf">select_pixel_bkg_maj</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">event</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Gestion de la selection des points de l&#39;arrière plan : quand l&#39;évènement event (se sera ctrl-click droit de la souris sur l&#39;image) se produit , la liste Liste_points_bkg est augmentee des coordonnees du point clique et l&#39;affichage de cette liste est mise a jour. </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param event: Objet Event  </span>
<span class="sd">        :type event: Event</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
    
        <span class="bp">self</span><span class="o">.</span><span class="n">select_pixel_bkg</span><span class="p">(</span><span class="n">event</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sv_bkg</span><span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="p">))</span></div>
    
<div class="viewcode-block" id="Application.calcule_boule_de_pixels_autour_de_pixel"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.calcule_boule_de_pixels_autour_de_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_boule_de_pixels_autour_de_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pixel_x</span><span class="p">,</span><span class="n">pixel_y</span><span class="p">,</span><span class="n">rayon</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Calcule la boule de pixels de rayon &#39;rayon&#39; autour du pixel de coordonnées pixel_x,pixel_y. </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param pixel_x: abscisse du pixel centre de la boule </span>
<span class="sd">        :type pixel_x: int</span>
<span class="sd">        </span>
<span class="sd">        :param pixel_y: ordonnée du pixel centre de la boule </span>
<span class="sd">        :type pixel_y: int</span>
<span class="sd">        </span>
<span class="sd">        :param rayon: rayon de la boule </span>
<span class="sd">        :type rayon: int</span>
<span class="sd">        </span>
<span class="sd">        :return: liste de pixels formant une boule de rayon &#39;rayon&#39; autour du pixel de coordonnées pixel_x,pixel_y.  </span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="n">L</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">dx</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="o">-</span><span class="n">rayon</span><span class="p">,</span><span class="n">rayon</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">dy</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="o">-</span><span class="n">rayon</span><span class="p">,</span><span class="n">rayon</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
                <span class="n">X</span><span class="o">=</span><span class="n">pixel_x</span><span class="o">+</span><span class="n">dx</span>
                <span class="n">Y</span><span class="o">=</span><span class="n">pixel_y</span><span class="o">+</span><span class="n">dy</span>
                <span class="k">if</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">X</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">largeur</span> <span class="ow">and</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">Y</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">hauteur</span><span class="p">:</span>
                    <span class="n">L</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">L</span></div>
 
        
<div class="viewcode-block" id="Application.calcule_boules_de_pixels_from_selection"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.calcule_boules_de_pixels_from_selection">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_boules_de_pixels_from_selection</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">liste</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Extension de la liste des pixels sélectionnés en boules de rayon self.Rayon. </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :param liste: liste des pixels à étendre </span>
<span class="sd">        :type liste: List</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        
        <span class="n">rayon</span><span class="o">=</span><span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Rayon</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
        <span class="n">L</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">pixel</span> <span class="ow">in</span> <span class="n">liste</span> <span class="p">:</span>
            <span class="n">L</span><span class="o">+=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_boule_de_pixels_autour_de_pixel</span><span class="p">(</span><span class="n">pixel</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span><span class="n">pixel</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="n">rayon</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">L</span>    </div>
        
        
<div class="viewcode-block" id="Application.import_image"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.import_image">[docs]</a>    <span class="k">def</span> <span class="nf">import_image</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> 
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        .. todo:: ???en test ??? comment remplacer l&#39;ancienne image par la nouvelle dans le canvas? Actuellement il reste un cadre gris. Peut-être raffraichir la fenetre recompletement ??? A chercher </span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1"># # Selection du nouveau fichier image a traiter au format PNG niveau de gris a l&#39;aide d&#39;une fenetre de selection</span>
        <span class="c1"># self.filepath = tkfd.askopenfilename(title=&quot;Ouvrir une image&quot;,filetypes=[(&#39;png files&#39;,&#39;.png&#39;),(&#39;all files&#39;,&#39;.*&#39;)])</span>
        <span class="c1"># </span>
        <span class="c1"># # Ouverture du fichier image a traiter au format PNG niveau de gris et stockage dans la variable photo</span>
        <span class="c1"># self.photo = tk.PhotoImage(file=self.filepath)</span>
        <span class="c1"># </span>
        <span class="c1"># # Affichage du fichier image</span>
        <span class="c1"># self.canvas.delete(tk.ALL)</span>
        <span class="c1"># self.canvas = tk.Canvas(self.fenetre, width=self.photo.width(), height=self.photo.height(), bg=&quot;gray&quot;)</span>
        <span class="c1"># self.canvas.create_image(0, 0, anchor=tk.NW, image=self.photo)</span>
        <span class="c1"># self.canvas.pack()</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Import de la nouvelle image !&quot;</span><span class="p">)</span></div>
    

<div class="viewcode-block" id="Application.calcul_zone"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.calcul_zone">[docs]</a>    <span class="k">def</span> <span class="nf">calcul_zone</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> 
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Calcul de la zone en fonction de la méthode choisie puis coloriage des points correspondants.</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">#extension des listes en fonction du rayon</span>
        <span class="n">L_obj</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_boules_de_pixels_from_selection</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="p">)</span>
        <span class="n">L_bkg</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_boules_de_pixels_from_selection</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="o">=</span><span class="n">L_obj</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="o">=</span><span class="n">L_bkg</span>

        <span class="c1"># création du graphe de flot</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;1&#39;</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;2&#39;</span> <span class="p">:</span>
            <span class="n">L_source</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span>
            <span class="n">L_puits</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span>
            <span class="n">pourcentage</span><span class="o">=</span><span class="nb">float</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Pourcentage</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
            <span class="c1">#print(&quot;pourcentages : &quot;,pourcentage)</span>
            <span class="n">graphe_flot</span><span class="o">=</span><span class="n">Graphe</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="p">,</span><span class="n">L_source</span><span class="p">,</span><span class="n">L_puits</span><span class="p">,</span><span class="n">pourcentage</span><span class="p">)</span>
        
        <span class="c1"># création de l&#39;objet partage des eaux</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;3&#39;</span><span class="p">:</span>
            <span class="n">PartageDesEaux</span><span class="o">=</span><span class="n">Partage_eaux</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_obj</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">Liste_points_bkg</span><span class="p">,</span><span class="n">Gamma</span><span class="p">[</span><span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">gamma</span><span class="o">.</span><span class="n">get</span><span class="p">())])</span>
            
        
        <span class="c1"># segmentation    </span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;1&#39;</span> <span class="p">:</span>
            <span class="n">Liste_points_a_colorier</span><span class="o">=</span><span class="n">graphe_flot</span><span class="o">.</span><span class="n">graph_cut</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">colorie_zone_img_RGB_np</span><span class="p">(</span><span class="n">Liste_points_a_colorier</span><span class="p">,</span><span class="s1">&#39;red&#39;</span><span class="p">)</span>
            
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;2&#39;</span><span class="p">:</span>
            <span class="n">Liste_points_a_colorier</span><span class="o">=</span><span class="n">graphe_flot</span><span class="o">.</span><span class="n">graph_cut_2</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">colorie_zone_img_RGB_np</span><span class="p">(</span><span class="n">Liste_points_a_colorier</span><span class="p">,</span><span class="s1">&#39;blue&#39;</span><span class="p">)</span>    
            
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;3&#39;</span><span class="p">:</span>
            <span class="n">PartageDesEaux</span><span class="o">.</span><span class="n">partage</span><span class="p">()</span>
            <span class="n">Liste_points_a_colorier</span><span class="o">=</span><span class="n">PartageDesEaux</span><span class="o">.</span><span class="n">extrait_liste_coordonnees_des_pixels_de_zone</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">zone_col</span><span class="o">.</span><span class="n">get</span><span class="p">()))</span>
            <span class="c1">#print(Liste_points_a_colorier)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">colorie_zone_img_RGB_np</span><span class="p">(</span><span class="n">Liste_points_a_colorier</span><span class="p">,</span><span class="s1">&#39;green&#39;</span><span class="p">)</span>    
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Fin des calculs vous pouvez afficher&#39;</span><span class="p">)</span></div>
    
    
<div class="viewcode-block" id="Application.affiche_zone"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.affiche_zone">[docs]</a>    <span class="k">def</span> <span class="nf">affiche_zone</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Affichage de l&#39;image RGB avec les zones coloriees.</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1">#print(&quot;Affichage de la zone segmentée!&quot;)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">affiche_image_RGB</span><span class="p">()</span></div>
    
    
<div class="viewcode-block" id="Application.exporte_image"><a class="viewcode-back" href="../tec_doc - Copie.html#Segmentation_GUI.Application.exporte_image">[docs]</a>    <span class="k">def</span> <span class="nf">exporte_image</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;&quot; </span>
<span class="sd">        Exportation de l&#39;image avec les zones coloriees au format png.</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Application  </span>
<span class="sd">        :type self: Application</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1">#print(&quot;Exportation du fichier de l&#39;image segmentée au format png!&quot;)  </span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;1&#39;</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;2&#39;</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">()</span><span class="o">==</span><span class="s1">&#39;3&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">export_image_2_file</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">no_algo</span><span class="o">.</span><span class="n">get</span><span class="p">())</span> 
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">img</span><span class="o">.</span><span class="n">export_image_2_file</span><span class="p">(</span><span class="s1">&#39;0&#39;</span><span class="p">)</span></div></div>
  
<span class="c1">### FIN DE LA FENETRE TKINTER / classe APPLICATION</span>


<span class="c1">###______Programme principal_______________________________________________________</span>
<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">f</span> <span class="o">=</span> <span class="n">Application</span><span class="p">()</span> <span class="c1"># instanciation de l&#39;objet application</span>
    

</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>